<?php
namespace Incoviba\Middleware;

use Psr\Http\Message\ResponseFactoryInterface;
use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;
use Psr\Http\Server\RequestHandlerInterface;
use Psr\Log\LoggerInterface;
use Slim\Exception\HttpNotFoundException;
use Incoviba\Common\Alias\View;

class NotFound
{
    public function __construct(protected LoggerInterface $logger, protected ResponseFactoryInterface $responseFactory, protected View $view) {}
    public function __invoke(ServerRequestInterface $request, RequestHandlerInterface $handler): ResponseInterface
    {
        try {
            return $handler->handle($request);
        } catch (HttpNotFoundException $exception) {
            $this->logger->notice($exception);
            $response = $this->responseFactory->createResponse(404);
            if (str_contains($request->getUri()->getPath(), '/api')) {
                return $response;
            }
            return $this->view->render($response, 'not_found');
        }
    }
}
